{-# LANGUAGE
    QuasiQuotes
  , UnicodeSyntax
  #-}
-- |The default extension map.
module Network.HTTP.Lucu.MIMEType.DefaultExtensionMap
    ( defaultExtensionMap
    )
    where
import Network.HTTP.Lucu.MIMEType.Guess

-- |'defaultExtensionMap' contains contains every possible pairs of an
-- extension and a MIME Type.
defaultExtensionMap :: ExtMap
{-# NOINLINE defaultExtensionMap #-}
defaultExtensionMap = [extMap|
# MIME type			Extensions
application/andrew-inset	ez
application/atom+xml		atom
application/mac-binhex40	hqx
application/mac-compactpro	cpt
application/mathml+xml		mathml
application/msword		doc
application/octet-stream	bin dms lha lzh exe class so dll dmg hi o
application/oda			oda
application/ogg			anx ogg ogm
application/pdf			pdf
application/postscript		ai eps ps
application/rdf+xml		rdf
application/smil		smi smil
application/srgs		gram
application/srgs+xml		grxml
application/vnd.mif		mif
application/vnd.mozilla.xul+xml	xul
application/vnd.ms-excel	xls
application/vnd.ms-powerpoint	ppt
application/vnd.rn-realmedia	rm
application/vnd.wap.wbxml	wbxml
application/vnd.wap.wmlc	wmlc
application/vnd.wap.wmlscriptc	wmlsc
application/voicexml+xml	vxml
application/x-3gp		3gp
application/x-ape		ape
application/x-ar		a
application/x-bcpio		bcpio
application/x-bzip		bz2 tbz
application/x-cdlink		vcd
application/x-chess-pgn		pgn
application/x-compress		Z
application/x-cpio		cpio
application/x-csh		csh
application/x-director		dcr dir dxr
application/x-dvi		dvi
application/x-futuresplash	spl
application/x-gtar		gtar
application/x-gzip		gz tgz
application/x-hdf		hdf
application/x-javascript	js
application/x-java-jnlp-file	jnlp
application/x-koan		skp skd skt skm
application/x-latex		latex
application/x-nar		nar
application/x-netcdf		nc cdf
application/x-rar		rar
application/x-sh		sh
application/x-shar		shar
application/x-shockwave-flash	swf swfl
application/x-spc		spc
application/x-stuffit		sit
application/x-sv4cpio		sv4cpio
application/x-sv4crc		sv4crc
application/x-tar		tar
application/x-tcl		tcl
application/x-tex		tex
application/x-texinfo		texinfo texi
application/x-troff		t tr roff
application/x-troff-man		man
application/x-troff-me		me
application/x-troff-ms		ms
application/x-ustar		ustar
application/x-wais-source	src
application/xhtml+xml		xhtml xht
application/xslt+xml		xslt
application/xml			xml xsl
application/xml-dtd		dtd
application/zip			zip
audio/basic			au snd
audio/iLBC-sh			ilbc
audio/midi			mid midi kar
audio/mp4a-latm			m4a m4p
audio/mpeg			mpga mp2 mp3
audio/x-ac3			ac3
audio/x-aiff			aif aiff aifc
audio/x-ircam			sf
audio/x-flac			flac
audio/x-mod			669 amf dsm gdm far imf it med mod mtm okt sam s3m stm stx ult xm
audio/x-mpegurl			m3u
audio/x-musepack		mpc
audio/x-nist			nist
audio/x-paris			paf
audio/x-pn-realaudio		ram ra
audio/x-sds			sds
audio/x-shorten			shn
audio/x-sid			sid
audio/x-svx			iff svx
audio/x-ttafile			tta
audio/x-voc			voc
audio/x-w64			w64
audio/x-wav			wav
audio/x-wavpack			wv wvp
audio/x-wavpack-correction	wvc
chemical/x-pdb			pdb
chemical/x-xyz			xyz
image/bmp			bmp
image/cgm			cgm
image/gif			gif
image/ief			ief
image/jpeg			jpeg jpg jpe
image/jp2			jp2
image/pict			pict pic pct
image/png			png
image/svg+xml			svg
image/tiff			tiff tif
image/vnd.djvu			djvu djv
image/vnd.wap.wbmp		wbmp
image/x-sun-raster		ras
image/x-macpaint		pntg pnt mac
image/x-icon			ico
image/x-jng			jng
image/x-portable-anymap		pnm
image/x-portable-bitmap		pbm
image/x-portable-graymap	pgm
image/x-portable-pixmap		ppm
image/x-quicktime		qtif qti qif
image/x-rgb			rgb
image/x-xbitmap			xbm
image/x-xcf			xcf
image/x-xpixmap			xpm
image/x-xwindowdump		xwd
model/iges			igs iges
model/mesh			msh mesh silo
model/vrml			wrl vrml
text/calendar			ics ifb
text/css			css
text/html			html htm
text/plain			asc txt
text/richtext			rtx
text/rtf			rtf
text/sgml			sgml sgm
text/tab-separated-values	tsv
text/uri-list			uni unis uri uris
text/vnd.wap.wml		wml
text/vnd.wap.wmlscript		wmls
text/x-c			c h
text/x-c++			cc cpp cxx hpp hxx
text/x-cabal			cabal
text/x-haskell			hs hsc lhs
text/x-setext			etx
video/mp4			mp4
video/mpeg			mpeg mpg mpe
video/mpeg4			m4v
video/mpegts			ts
video/quicktime			qt mov
video/vnd.mpegurl		mxu m4u
video/x-dv			dv dif
video/x-fli			flc fli
video/x-flv			flv
video/x-matroska		mkv  mka
video/x-ms-asf			asf wm wma wmv
video/x-msvideo			avi
video/x-mng			mng
video/x-mve			mve
video/x-nuv			nuv
video/x-sgi-movie		movie
x-conference/x-cooltalk		ice
|]
